/***
 * Excerpted from "The ThoughtWorks Anthology",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/twa for more book information.
***/
//package com.nealford.conf.pp.initializers;

public class LoadEmUp {
    private Referee _referee = new Referee();

    { System.out.println("Told you so");
    }

    static {
        System.out.println("Did too");
    }
    
    public LoadEmUp() {
        System.out.println("Did not");
        _referee = new Referee(this);
    }

    static {
        System.out.println("Did not");
    }
    public static void main(String[] args) {
        new LoadEmUp();
        System.out.println("Did too");
        Referee referee = new Referee();
    }
}

class Referee {

    public Referee() {
        System.out.println("stop fighting!");
    }

    public Referee(Object owner) {
        System.out.println("I told you to stop fighting!");
    }
}
