#---
# Excerpted from "The ThoughtWorks Anthology",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/twa for more book information.
#---
require 'model'

class RulesBuilder7
  def load aStream
    $config = Configuration.new
    eval(aStream.join("\n"))
    return $config
  end
end

def item name
  $config.add_item(Item.new(name))
end

def uses item, resource
  $config[item].add_usage(resource)
end

def acid_type acid, type
  $acids[acid].type = type
end

def acid_grade acid, grade
  $acids[acid].grade = grade
end

def provides item, resource
  $config[item].add_provision(resource)
end

def depends client, supplier
  $config[client].add_dependency($config[supplier])
end

$acids = {}

def acid name
  $acids[name] = Acid.new
end

def electricity power
  return Electricity.new(power)
end


