/***
 * Excerpted from "The ThoughtWorks Anthology",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/twa for more book information.
***/
package com.nealford.conf.pp.initializers;

import java.util.ArrayList;

/**
 * User: Neal Ford
 * Date: Dec 26, 2006
 * Time: 9:14:04 PM
 * <cite>Incidentally, created by IntelliJ IDEA.</cite>
 */
public class LessFunWithInitializers {
    public LessFunWithInitializers() {
        MyList<String> list = new MyList<String>();
        for (String s : list)
            System.out.println(s);
    }

    public static void main(String[] args) {
        new LessFunWithInitializers();
    }
}

class MyList<T> extends ArrayList<T> {
    {
        add((T) "The Godfather");
        add((T)"The Shawshank Redemption");
        add((T)"The Godfather Part II");
        add((T)"The Lord of the Rings: The Return of the King");
    }
}
